/* Interface File for the SeismicData Class */
/*	Written by:  TB  9/91 */

#import <objc/Object.h>		/* get header of superclass */
#import <stdio.h>
#import "ahhead.h"		/* ah data file header */


@interface SeismicData:Object
{
	ahhed header;			/* structure to hold header values */
	float *data;			/* pointer to the data structure */
	FILE	*pt;			/* pointer to input data file */
}

- init:(id)sender;
- setFilePointer: (FILE *)pt;
- getAhData:(char *)data andHeader:(ahhed *)header;
- getLength:(int *)length;
- getAhData:(char *)data;
- putAhData:(char *)data andHeader:(ahhed *)header;
- readAhRecord:(int)num;
- writeAhRecord;
- (char *)getAhComment;
- getDataType:(int *)type;
- getDataSegment:(int)segment ofLength:(int *)length andSampleInterval:(float *)dt
	withMaxValue:(float *)maxvalue forPlot:(float **)data;
- fourier;
- scaleData:(float)scale;
	
	/* internal methods */
- setMaxAmp;
- readAhHeadFromFile;
- readAhDataFromFile;
- putAhHeadToFile;
- putAhDataToFile;
- (int)size;
- positionFile:(int)num;
- makeDataSpace;
- nullTheHeader;
	
@end