
/* Generated by Interface Builder */

#import "SoundPlayer.h"
#import "SeismicData.h"
#import "SpecView.h"
#import <appkit/Application.h>
#import <appkit/Control.h>
#import <appkit/Window.h>
#import <appkit/OpenPanel.h>
#import <appkit/Panel.h>
#import <soundkit/Sound.h>
#import <soundkit/SoundView.h>
#import <string.h>
#import <stdio.h>
#import <math.h>


#define XOFFSET -10.0 	// Offset of subsequent windows
#define YOFFSET -20.0
#define NMAX 30000

@implementation SoundPlayer

	/* action methods */
- show:sender
{
	[myWindow makeKeyAndOrderFront:self];
    	return self;
}

- close:sender
{
	[myWindow close];
	return self;
}

	/* initialization methods */
- init
{
	BOOL got_file=NO;
	int data_type,i;
	float yd[NMAX][4],max,*xi,*xo,*ofdata;
	
	void intcub (int ideriv, int nin, float xin[], float ydin[][4], 
	int nout, float xout[], float yout[]);
	void cmonot (int n, float x[], float y[], float yd[][4]);
		
	[super init];	/* init of super class */
	
		/* establish id for the procedure to open a file panel */
	openPanel=[OpenPanel new];
	
		/* now get the file name */
	got_file=[self openRequest:self];
	
	if(got_file == YES)	/* got the file, open the window */
	{
			/* load the soundPlayer.nib and set its title */
		[NXApp loadNibSection:"soundPlayer.nib" owner:self];
		[myWindow setTitle:FN];
		[myWindow setDelegate:self];
		
			/* Put the window offset from the previous window doc.. */
		if([NXApp mainWindow])
		{
			NXRect winFrame, winLoc;	/* variable defs */
			[[NXApp mainWindow] getFrame:&winFrame];
			[[myWindow class] getContentRect:&winLoc
                        	forFrameRect:&winFrame style:[myWindow style]];
       			[myWindow moveTo:NX_X(&winLoc) + XOFFSET :NX_Y(&winLoc) + YOFFSET];
		}

			/* allocate and initialize seismic data class */
		tseisData=[[SeismicData alloc] init];
		fseisData=[[SeismicData alloc] init];
		
			/* set data file pointer */
		[tseisData setFilePointer:fp];
		[fseisData setFilePointer:fp];
		
			/* read data */
		[tseisData readAhRecord:0];
		[fseisData readAhRecord:1];
		
			/* extract plot data record */
		[tseisData getDataType:&data_type];
		if(data_type != FLOAT)
		{
			NXRunAlertPanel("SoundPlayer...",
				"Data File does not Contain Times Series Data\n",
				"OK", 0, 0);
			[myWindow close];
			return nil;
		}
		else
		{
				/* Fourier transform data and extract */
			[fseisData fourier];
			[fseisData getDataSegment:(int)REAL ofLength:&length andSampleInterval:&dt
				withMaxValue:&mval forPlot:&plot_data];
		}
		
			/* initialize the SpecView's instance variables */
		[mySpecView setDt:dt];
		[mySpecView setMaxValue:mval];
		[mySpecView setLength:length/4];	/* plot only the 1/4 of the spectra */
		[mySpecView setData:plot_data];
		
			/* plot spectra */
		[mySpecView display];
		
			/* display trace title in myTextField */
		[myTextField setStringValue:(const char *)[fseisData getAhComment]];
		
			/* prepare sound for display */
			/* first scale the sound */
		[tseisData scaleData:30000.0];
		
			/* prepare to get data and interpolate it */
		interp=10;
		[tseisData getLength:&ilength];
		idata=(float *)calloc(ilength,sizeof(float));
		[tseisData getAhData:(char *)idata];

		if(ilength > NMAX)ilength=NMAX;		
		xi=(float *)calloc(ilength,sizeof(float));
		olength=(ilength-1)*interp;
		ofdata=(float *)calloc(olength,sizeof(float));
		odata=(short *)calloc(olength,sizeof(short));
		xo=(float *)calloc(olength,sizeof(float));
		
		
			/* scale data */
		max=0.0;
		for(i=0;i<ilength;i++)
			if(fabs(idata[i]) > max)max=fabs(idata[i]);
		for(i=0;i<ilength;i++)idata[i]=idata[i]/max * 30000.0;
		
			/* setup y values */
		for(i=0;i<ilength;i++)xi[i]=(float)i;
		for(i=0;i<olength;i++)xo[i]=(float)(i)/interp;
		
			/* interpolate data */
		cmonot(ilength,xi,idata,yd);
		intcub(0,ilength,xi,yd,olength,xo,ofdata);
		
			/* put interpolated data in an array of shorts */
		for(i=0;i<olength;i++)
			odata[i]=(short)ofdata[i];
		
			/* setup sound object */
		qSound = [Sound new];
		[qSound setDataSize:olength*sizeof(short)
			dataFormat:SND_FORMAT_LINEAR_16 
			samplingRate:SND_RATE_LOW
			channelCount:1
			infoSize:4];
		sdata=[qSound data];
		memcpy(sdata,(char *)odata,olength*sizeof(short));
		[myQuakeView setSound:qSound];
		
	}
	free((void *)idata);
	free((void *)ofdata);
	free((void *)xi);
	free((void *)xo);

	return self;
}

	/* methods to get filename and handle the file panels */
- appOpenFile:(char *)filename type:(char *)filetype
{
	return [self openFile:filename];
}

- openFile:(const char *)filename
{	
		/* attempt to open file */
	if ((fp=fopen(filename,"r"))==NULL) return NO;
	
		/* copy filname to a string for naming the window */
	strcpy(FN,filename);
			
	return self;
}

- (BOOL)openRequest:sender
{
	BOOL got_file=NO;
	
		/* define types string. This definition will */
		/* will list only directories or those files */
		/* ending with ah */
	char *types[2] = {"ah",NULL}; 

		/* Display the open panel on the screen and */
		/* get selected file name */
	if ([openPanel runModalForTypes:types])
	{
		[self openFile:[openPanel filename]];
		got_file=YES;
	}

    return (got_file);
}

@end
