
/* Generated by Interface Builder */

#import "DataView.h"
#import <dpsclient/wraps.h>
#import <ipsplot.h>
#import <appkit/Application.h>
#import <appkit/NXCursor.h>



@implementation DataView

- initFrame:(const NXRect *)frameRect
{
	[super initFrame:(const NXRect *)frameRect];
	x=NULL,y=NULL;
	xmin=ymin=0.0;
	num=0;
	
	return self;
}


- setXMax:(float)value
{
	xmax=value;
	
	return self;
}

-setYMax:(float)value
{
	ymax=value;
	
	return self;
}

- drawSelf:(const NXRect *)rects :(int)rectCount
{

	int bbox[4];
	char xtitle[100],ytitle[100];
	
	/* load the data from the delegate */
	
	if(delegate && [delegate respondsTo:@selector(sendDataToPlot::::::)])
		[delegate sendDataToPlot:self:&x:&y:&num:xtitle:ytitle];
		
	/* initialize plot area */
	
	PSgsave();
        PSsetgray(1.0);
        PSrectfill(bounds.origin.x,bounds.origin.y,bounds.size.width,bounds.size.height);
	PSsetgray(0.0);
        PSgrestore();
	
	if(x != NULL && xmax != 0.0)	/* we were able to get data so plot it */
	{
		
				
		/* set width and height of plot area */
	
		Vhbox=bounds.size.width*0.87;
		Vwbox=bounds.size.height*0.87;
		Vybox=bounds.size.width*0.05;
		Vxbox=bounds.size.height*0.05;
	
		/* set up to plot data */

		PSinitclip();
		PSgsave();
			
		PSrotate(-90.0);
		PStranslate((-1.0*bounds.size.height),0.0);
		PStranslate(Vxbox,Vybox);
	
		/* plot axes */	
		
		psAxesBBox(Vxbox,Vybox,Vwbox,(Vhbox+Vhbox*0.01),"Ohlfs",10.0,
			"Ohlfs",10.0,NORMAL,bbox);
		boundingbox(bbox[0],bbox[1],bbox[2],bbox[3]);
	
			/* draw axes and title */
		PSsetgray(0.0);
		ipsAxesBox(Vxbox,Vybox,Vwbox,(Vhbox+Vhbox*0.01),0.0,xmax,0.0,0.0,0,0,1,
			NONE,"",0.0,(1.1*ymax),0.0,0.0,0.0,0,1,NONE,
			"","Ohlfs",10,"",
			"Ohlfs",10,NORMAL);
			
		PStranslate(Vxbox,Vybox);
		xscale=Vwbox/xmax;
		yscale=Vhbox/(1.1*ymax);

		/* plot data */
		
		[self drawModel];
		
		
		PSgrestore();
	}
	
	return self;
}	

- drawModel
{
	int i;
	
	PSmoveto(0.0,y[0]*yscale);
	PSlineto(x[0]*xscale,y[0]*yscale);
	PSsetgray(0.0);
	for(i=1;i<num;i++)
	{
		PSlineto(x[i-1]*xscale,y[i]*yscale);
		PSlineto(x[i]*xscale,y[i]*yscale);
	}
	PSstroke();

	return self;
}	


- mouseDown:(NXEvent *)theEvent
{
        int i,sp,oldmask,mouseup=NO;
      	float dist,sdist,xpos,ypos;
	char locstr[50];
        NXEvent *event;
	NXPoint	point;
	
        	/* save old event mask */
        oldmask = [window addToEventMask:NX_LMOUSEDRAGGEDMASK];

        	/* set up for changing model */
        [self lockFocus];
       	PSsetgray(0.333);
        PSsetinstance(YES);
	PSselectfont("Ohlfs",9.0);
	
		/* determine velocity boundary nearest the choosen point */
	point=theEvent->location;
        [self convertPoint:&point fromView:nil];
	dist=10000000.0,sp=0;
	for(i=0;i<num;i++)
	{		/* convert event location to plot coordinates */
		xpos=(bounds.size.height-2.0*Vxbox-point.y)/xscale;
		ypos=(point.x-2.0*Vybox)/yscale;
		if(i != 0)
			sdist=(ypos-y[i])*(ypos-y[i])+(xpos-x[i-1])*(xpos-x[i-1]);
		else
			sdist=(ypos-y[i])*(ypos-y[i])+xpos*xpos;
		if(sdist < dist)
		{
			dist=sdist;
			sp=i;
		}
	}
	
		/* change model to reflect new point */
	if(sp != 0) x[sp-1]=xpos;
	y[sp]=ypos;
	
		/* change coordinate frame to that used in drawself */
	PSrotate(-90.0);
	PStranslate((-1.0*bounds.size.height),0.0);
	PStranslate(2.0*Vxbox,2.0*Vybox);
	
		/* redraw and instance of the model */
	[self drawModel];
		
		/* label point where the mouse is */
	sprintf(locstr,"(%.4f,%.4f)",xpos,ypos);
	PSrotate(90.0);
	PSmoveto(-18.0,20.0);
	PSshow(locstr);
	PSrotate(-90.0);
	
	
        	/* loop until mouse up */
        while(!mouseup) 
	{
               		 /* get mouse event and location */
                event = [NXApp getNextEvent:
                        (NX_LMOUSEUPMASK | NX_LMOUSEDRAGGEDMASK)];
               	point = event->location;
                [self convertPoint:&point fromView:nil];
                
                	/* if mouse up, break */
               	if (event->type==NX_LMOUSEUP) 
		{
                       	mouseup=YES;
                
                }
		else /* else if mouse dragged, update velocity model */
               {
			 if (event->type==NX_LMOUSEDRAGGED) 
			 {
			 		/* change model array to reflect mouse movement */
				xpos=(bounds.size.height-2.0*Vxbox-point.y)/xscale;
				ypos=(point.x-2.0*Vybox)/yscale;
				
					/* don't allow unreasonable depths */
				if(sp == 1)	/* don't let top layer have a depth of zero or less */
					if(xpos < 0.0) xpos=0.01;
				if(sp > 1)	/* don't let other layers be shallower than the layers above */
					if(xpos < x[sp-2])xpos=x[sp-2]+0.01;
				if(xpos > x[sp])	/* don't let layer be deeper than layer below */
					xpos=x[sp]-0.01;
					
					
				if(sp != 0) x[sp-1]=xpos;
				y[sp]=ypos;
				
					/* redraw instance of the model */
				PSnewinstance();
				[self drawModel];
				
					/* label point where the mouse is */
				sprintf(locstr,"(%.4f,%.4f)",xpos,ypos);
				PSrotate(90.0);
				PSmoveto(-18.0,20.0);
				PSshow(locstr);
				PSrotate(-90.0);
			}
                }
        }
        
	
	
       		 /* finished drawing */
        PSnewinstance();
        PSsetinstance(NO);
        [self unlockFocus];
        
        	/* restore event mask */
        [window setEventMask:oldmask];
	
		/* update all views with new model */
	if(delegate && [delegate respondsTo:@selector(dataChanged:)])
		[delegate dataChanged:self];

	
	return self;
}

- resetCursorRects
{
    NXRect visible;
    if ([self getVisibleRect:&visible]) {
        [self addCursorRect:&visible cursor:NXArrow];
    }
    return self;
}

@end

