
/* Generated by Interface Builder */

#import "PsSpecView.h"
#import "PsSpecControl.h"

#import <ipsplot.h>
#import <dpsclient/wraps.h>
#import <appkit/Control.h>
#import <appkit/Form.h>
#import <appkit/Application.h>
#import <appkit/NXCursor.h>

#import <stdlib.h>
#import <stdio.h>
#import <math.h>


@implementation PsSpecView

- initFrame:(const NXRect *)frameRect
{
	[super initFrame:(const NXRect *)frameRect];
	[self setValues];
	data=(float *)calloc(8192,sizeof(float));

	return self;
}
- setValues
{
	damp=10;
	freq=1.0;
	xmin=ymin=0.0;
	xmax=ymax=1.0e+25;
	Enlarged=NO;
	pstart=pend=0;
	length=0;
	y=NULL;
	
	return self;
}

- prepareText
{

	/* initialize the two textfields */
	[ampForm setStringValue:" "];
	[freqForm setFloatValue:freq at:0];	
	[dampForm setIntValue:damp at:0];
	return self;
}

- drawSelf:(const NXRect *)rects :(int)rectCount
{
	int bbox[4],i,j;
	float w,w0,*osc,*temp,fdamp;
	
		/* function prototypes */
	void t_fold(float *a,int ndata_a,float *b,int ndata_b,float *result);

	/* load the data from the delegate */
	
	if(delegate && [delegate respondsTo:@selector(sendDataToPlot::::)])
		[delegate sendDataToPlot:self:&y:&length:&dt];
	
	/* initialize plot area */
	
	PSgsave();
        PSsetgray(1.0);
        PSrectfill(bounds.origin.x,bounds.origin.y,bounds.size.width,bounds.size.height);
	PSsetgray(0.0);
        PSgrestore();
	
	[self prepareText];

	/* we're able to plot spectra so, calculate and plot */
	if(y != NULL)
	{

		/* allocate a temporary array to hold the response of the damped oscillator */
		osc=(float *)calloc(length,sizeof(float));
		temp=(float *)calloc(length*2+2,sizeof(float));
		
			/* now loop through all frequencies and construct spectra */
		fdamp=damp/100.0;	/* convert % to fraction */
		
		w0=(float)freq*6.28318531;
		w=w0*sqrt((1.0-fdamp*fdamp));
			
		/* first construct oscillator response */
		for(j=0;j<length;j++)
			osc[j]=exp((-1.0*w0*fdamp*j*dt))*sin((w*j*dt+1.57079633));
				
		/* now convolve with our input response and find max value */
		t_fold(osc,length,y,length,temp);
			
		/* set data array */
		for(i=0;i<length;i++)data[i]=temp[i];
		
		if(Enlarged == NO)
		{
			pstart=0;
			pend=length;
		}
		if(Enlarged == YES)
		{
			if(pend >= length) pend=length;
			if(pstart < 0)pstart=0;
			length=pend-pstart;
		}

		/* determine xmax and ymax */
		ymax=0.0;
		for(i=pstart;i<pend;i++)
			if(ymax < fabs(data[i]))ymax=fabs(data[i]);
		xmax=(length-1)*dt;
		
		/* publish maximum value */
		[ampForm setFloatValue:ymax];

		/* set width and height of plot area */
		Vwbox=bounds.size.width*0.9;
		Vhbox=bounds.size.height*0.8;
		Vxbox=bounds.size.width*0.05;
		Vybox=bounds.size.height*0.1;
		
		/* set up scale for instance drawing */
		xscale=Vwbox/(xmax);
		yscale=Vhbox/(1.05*ymax);
	
		/* set up to plot data */
		PSinitclip();
		PSgsave();			
		PStranslate(Vxbox,Vybox);
		
		/* plot data */	
		PSsetgray(0.0);
		ipsWiggle(length,(data+pstart),(-1.05*ymax),(1.05*ymax),0.0,0.0,Vhbox,0.0,Vwbox,0);
		
		PSgrestore();

		/* set bounding box */
		PSsetgray(0.0);
		psAxesBBox(Vxbox,Vybox,Vwbox,(Vhbox+Vhbox*0.01),"Times-Roman",12.0,
			"Times-Roman",12.0,NORMAL,bbox);
		boundingbox(bbox[0],bbox[1],bbox[2],bbox[3]);
	
		/* draw axes and title */
		ipsAxesBox(Vxbox,Vybox,Vwbox,(Vhbox+Vhbox*0.01),0.0,xmax,0.0,0.0,0,0,1,NONE,"",
			(-1.05*ymax),(1.05*ymax),0.0,0.0,0.0,0,1,NONE,"","Times-Roman",12," ",
			"Times-Roman",12,NORMAL);

		free((void *)temp);
		free((void *)osc);	
	}
	return self;
}

- mouseDown:(NXEvent *)theEvent
{
        int oldmask,mouseup=NO,test,test1;
	float xorig,yorig,xb,yb,x,ly,x2,y2,w,h;
	float datppix,delta;
        NXEvent *event;
	NXPoint	mstart,mend,temp;

        /* remember initialize origin and size */
        mstart = theEvent->location;
        [self convertPoint:&mstart fromView:nil];
        x = xorig = mstart.x;
        ly = yorig = mstart.y;
        w = h = 0.0;
	
        /* save old event mask */
        oldmask = [window addToEventMask:NX_LMOUSEDRAGGEDMASK];
	
        /* set up for drawing rubber box */
        [self lockFocus];
       	PSsetgray(0.333);
       	PSsetinstance(YES);
        
        /* loop until mouse up */
        while(!mouseup) 
	{ 
               	/* get mouse event and location */
                event = [NXApp getNextEvent:
                        (NX_LMOUSEUPMASK | NX_LMOUSEDRAGGEDMASK)];
               	mend = event->location;
                [self convertPoint:&mend fromView:nil];
                
                /* if mouse up, break */
               	if (event->type==NX_LMOUSEUP) 
		{
                       	mouseup=YES;
                
                }
		else /* else if mouse dragged, update rubber box */
                {
			 if (event->type==NX_LMOUSEDRAGGED) 
			 {
                       	 	xb = mend.x;
                       	 	yb = mend.y;
                       	 	x = (xb<xorig)?xb:xorig;
                       		ly = (yb<yorig)?yb:yorig;
                       	 	x2 = (xb>xorig)?xb:xorig;
                        	y2 = (yb>yorig)?yb:yorig;
                        	w = x2-x;
                        	h = y2-ly;
                        	if (w!=0.0 && h!=0.0) 
				{
                               	 	PSnewinstance();
					PSrectstroke(x,Vybox,w,Vhbox+2);
                        	}
			}
                }
	}
	
		
       		 /* finished drawing */
        PSnewinstance();
        PSsetinstance(NO);
        [self unlockFocus];
        
        	/* restore event mask */
        [window setEventMask:oldmask];

	/* make sure the order of the picked points is correct */
	if(mend.x < mstart.x)
	{
		temp=mend;
		mend=mstart;
		mstart=temp;
	}

	/* first convert zoom range into a data subscript range */
	datppix=length/Vwbox;
	delta=mstart.x-Vxbox;
	test=(int)(datppix*delta);
	delta=mend.x-Vxbox;
	test1=(int)(datppix*delta);
	pend=pstart+test1;
	pstart += test;

		/* single click will re-establish original plot */
	if(pend-pstart < 2)
		Enlarged=NO;
	else
		Enlarged=YES;
		
	[self display];
	return self;
}


- resetCursorRects
{
    NXRect visible;
    if ([self getVisibleRect:&visible]) {
        [self addCursorRect:&visible cursor:NXArrow];
    }
    return self;
}
	/* action methods */
- getDamping:sender
{
	damp=[dampForm intValueAt:0];
	
	/* we currently don't allow over damping */
	if(damp > 100)
	{
		damp=100;
		[dampForm setIntValue:damp at:0];
	}
	if(damp < 0)
	{
		damp=0;
		[dampForm setIntValue:damp at:0];
	}
	
	/* update plot */
	[self display];
	return self;
}

- getFrequency:sender
{
	freq=[freqForm floatValueAt:0];
	
	if(freq < 0.01)
	{
		freq=0.01;
		[freqForm setFloatValue:freq at:0];
	}
	
	/* update plot */
	[self display];
	return self;
}

@end

