
/* Generated by Interface Builder */

#import "SourceView.h"
#import <dpsclient/wraps.h>
#import <ipsplot.h>
#import <appkit/Application.h>
#import <appkit/NXCursor.h>
#import <stdlib.h>
#import <stdio.h>

@implementation SourceView

- initFrame:(const NXRect *)frameRect
{
	[super initFrame:(const NXRect *)frameRect];
	x=NULL;
	length=0;

	return self;
}

- drawSelf:(const NXRect *)rects :(int)rectCount
{
	int bbox[4],i;
	float scale;
	
	/* load the data from the delegate */
	
	if(delegate && [delegate respondsTo:@selector(sendDataToPlot::::)])
		[delegate sendDataToPlot:self:&x:&length:&dt];
		
	/* initialize plot area */
	
	PSgsave();
        PSsetgray(1.0);
        PSrectfill(bounds.origin.x,bounds.origin.y,bounds.size.width,bounds.size.height);
	PSsetgray(0.0);
        PSgrestore();

	if(x != NULL)		/* we were able to get data so plot it */
	{
	
		/* data must be between 0 and 1 */
	scale=0.0;
	for(i=0;i<length;i++)
	{
		if(scale < x[i])scale=x[i];
		if(x[i] < 0.0)x[i]=0.0;
	}
	for(i=0;i<length;i++)
		x[i] /= scale;
		

		/* set width and height of plot area */
	
		Vwbox=bounds.size.width*0.85;
		Vhbox=bounds.size.height*0.85;
		Vxbox=bounds.size.width*0.08;
		Vybox=bounds.size.height*0.15;
		
		/* set up scale for instance drawing */
		
		xscale=Vwbox/(length*dt);
		yscale=Vhbox/(1.05);
	
		/* set up to plot data */

		PSinitclip();
		PSgsave();
			

		PStranslate(Vxbox,Vybox);
		
		/* plot data */	
		PSsetgray(0.0);
		ipsWiggle(length,x,0.0,1.05,0.0,0.0,Vhbox,0.0,Vwbox,0);
		PSgrestore();

	
		/* plot axes */	
		
		psAxesBBox(Vxbox,Vybox,Vwbox,(Vhbox+Vhbox*0.01),"Ohlfs",8.0,
			"Ohlfs",8.0,NORMAL,bbox);
		boundingbox(bbox[0],bbox[1],bbox[2],bbox[3]);
	
			/* draw axes and title */
		PSsetgray(0.0);
		ipsAxesBox(Vxbox,Vybox,Vwbox,(Vhbox+Vhbox*0.01),0.0,(length*dt),
			0.0,0.0,0,0,1,NONE,"",0.0,1.05,0.0,0.0,0.0,0,1,NONE,
			"","Ohlfs",8,"",
			"Ohlfs",8,NORMAL);
	}
	return self;
}

- mouseDown:(NXEvent *)theEvent
{
        int oldmask,mouseup=NO,i;
	float xval,yval,*tarray;
	NXPoint point;
        NXEvent *event;

	/* allocate a temporary array for plotting */
	tarray=(float *)calloc(length,sizeof(float));
		
	/* copy existing source time function into array */
	for(i=0;i<length;i++)
		tarray[i]=x[i];
		
        /* save old event mask */
        oldmask = [window addToEventMask:NX_LMOUSEDRAGGEDMASK];

        /* set up for drawing */
        [self lockFocus];
       	PSsetgray(0.333);
       	PSsetinstance(YES);

	/* convert point to our cordinates */
	point=theEvent->location;
	[self convertPoint:&point fromView:nil];
	xval=(point.x-Vxbox)/xscale;
	yval=(point.y-Vybox)/yscale;
	
	/* check bounds of point */
	if(yval < 0.0)yval=0.0;
	
	/* find xvalue in array closest to xval */
	i=0;
	while(xval > (float)(dt*i)) i++;
	if(i > length-1)i=length-1;
	tarray[i]=yval;
		
	/* draw array */
	PStranslate(Vxbox,Vybox);
	ipsWiggle(length,tarray,0.0,1.05,0.0,0.0,Vhbox,0.0,Vwbox,0);
	
		
	/* now loop while mouse is down */
	while(!mouseup) 
	{ 
                /* get mouse event and location */
                event = [NXApp getNextEvent:
                        (NX_LMOUSEUPMASK | NX_LMOUSEDRAGGEDMASK)];
               	point = event->location;
                [self convertPoint:&point fromView:nil];
                
                /* if mouse up, break */
               	if (event->type==NX_LMOUSEUP) 
		{
                       	mouseup=YES;
                
                }
		else /* else if mouse dragged, update rubber box */
                {
			 if (event->type==NX_LMOUSEDRAGGED) 
			 {
				/* convert point to our cordinates */
				point=theEvent->location;
				[self convertPoint:&point fromView:nil];
				xval=(point.x-Vxbox)/xscale;
				yval=(point.y-Vybox)/yscale;
				if(yval < 0.0)yval=0.0;
	
				/* find xvalue in array closest to xval */
				i=0;
				while(xval > (float)(dt*i)) i++;
				if(i > length-1)i=length-1;
				tarray[i]=yval;

		
				/* draw array */
				PSnewinstance();
				ipsWiggle(length,tarray,0.0,1.05,0.0,0.0,Vhbox,0.0,Vwbox,0);
                        }
		}
        }
        
       	/* finished drawing rubber box */
        PSnewinstance();
        PSsetinstance(NO);
        [self unlockFocus];
        
        /* restore event mask */
        [window setEventMask:oldmask];
	
	/* copy new values in the array maintained by the delegate */
	for(i=0;i<length;i++)
		x[i]=tarray[i];

	/* free temporary array */
	free((void *)tarray);
	
	/* redisplay area */
	[self display];
	
	return self;
}

- resetCursorRects
{
    NXRect visible;
    if ([self getVisibleRect:&visible]) {
        [self addCursorRect:&visible cursor:NXArrow];
    }
    return self;
}

@end
